﻿/**
COM。

etc.negui.readme参照。

History:
	$(HIST_VER 1.010,
		$(HIST_S packageをNeGuiに移動。)
	)
	$(HIST_VER 1.00β13,
		$(HIST_NEW)
	)
*/
module etc.negui.com.com;

debug import std.stdio: wl = writefln;
debug(com) void main() {}

import std.exception;

public import win32.windows;
public static import shlobj=win32.shlobj;

//public import etc.negui.system.raii;
import etc.negui.system.raii;
//public import nemuxi.system.exception;
//import nemuxi.system.exception;

/**
History:
	$(HIST_VER 1.020,
		$(HIST_S 継承元変更。)
	)
*/
class ComException: NeGuiException {
	mixin MixInNeGuiException;
}

///
void ComInitialize() {
	CoInitialize(null);
}

///
void ComUnInitialize() {
	CoUninitialize();
}

enum :DWORD {
	CLSCTX_INPROC_SERVER  = 0x01,
	CLSCTX_INPROC_HANDLER = 0x02,
	CLSCTX_LOCAL_SERVER   = 0x04,
	CLSCTX_ALL            = 0x17,
}
///
enum COM_CONTEXT: DWORD {
	INPROC_SERVER  = CLSCTX_INPROC_SERVER,  /// このクラスのオブジェクトを作成および管理するコードは、呼び出し側と同じプロセスで実行されるDLLです。
	INPROC_HANDLER = CLSCTX_INPROC_HANDLER, /// このクラスのオブジェクトを管理するコードはプロセス内ハンドラです。これはクライアントプロセス内で実行されるDLLで、クラスのインスタンスがリモートでアクセスされる際にこのクラスのクライアントサイド構造を作成します。
	LOCAL_SERVER   = CLSCTX_LOCAL_SERVER,   /// このクラスのオブジェクトを作成および管理するEXEコードは同じマシン上で実行されますが、別のプロセス空間にロードされます。
	ALL            = CLSCTX_ALL,            /// 上記の3つのフラグをすべて含んでいます。
}

/**
Note:
	なんでComとComBaseに分けてるのか忘れた。
	キチンとした意味があったはず。
*/
abstract class ComBase: Raii {
	/**
	*/
	protected this(bool Suicide) {
		super(Suicide);
	}
	abstract {
		///
		size_t addRef();
		///
		size_t release();
		
		///
		IUnknown iUnKnow();
	}
}


/**
ラッパー。

これでうまく行くのか非常に心配。
*/
class Com(TKNOWN: IUnknown): ComBase {
	///
	protected TKNOWN Known;

	protected override void Kill() {
		if(Known) {
			Known.Release();
		}
	}

	/**
	*/
	protected this(bool Suicide) {
		super(Suicide);
	}
	/**
	History:
		$(HIST_VER 1.100,
			$(HIST_P CoCreateInstance失敗時に例外。)
		)
	*/
	this(const ref CLSID ClsID, const ref GUID GuID, Com Com, COM_CONTEXT Context, bool Suicide=true) {
		auto Result=CoCreateInstance(&ClsID, Com ? Com.Known: null, Context, &GuID, cast(void**)&Known);
		enforce(Result == S_OK, new ComException(Text("%s [%s:%08X]", ERR.toText, Result, Result)));
		this(true);
	}

	final {
		override {
			///
			size_t addRef() {
				return Known.AddRef();
			}
			///
			size_t release() {
				return Known.Release();
			}
		}
		/***/
		Com!(T) query(T: IUnknown)(const ref GUID GuID) {
			auto com=new Com!(T)(false);
			
			if(Known.QueryInterface(cast(GUID*)&GuID, cast(void**)&com.Known) == S_OK) {
				com.Suicide = true;
				return com;
			}
			
			return null;
		}

		/***/
		override IUnknown iUnKnow() {
			return Known;
		}
		/***/
		TKNOWN opDot() {
			return Known;
		}
	}
}

