﻿/**


*/
module etc.negui.com.ipersistfile;

debug import std.stdio: wl = writefln;
debug(ipersistfile) void main() {}

public static import shlobj=win32.shlobj;
import win32.wtypes;

import etc.negui.system.text;
//import nemuxi.system.text;
import etc.negui.com.com;
import etc.negui.com.ipersist;

extern(C) {
	CLSID IID_IPersistFile= {0x0000010B, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
}

/***/
interface IPersistFile: IPersist {
	HRESULT IsDirty();
	HRESULT Load(LPCOLESTR, DWORD);
	HRESULT Save(LPCOLESTR, BOOL);
	HRESULT SaveCompleted(LPCOLESTR);
	HRESULT GetCurFile(LPOLESTR*);
}

///
enum STGM {
	DIRECT           = STGM_DIRECT,           /// ダイレクトモード$(DDOC_BLANKLINE)ストレージに対する変更はすぐに行われる。
	TRANSACTED       = STGM_TRANSACTED,       /// トランザクトモード。$(DDOC_BLANKLINE)変更は明示的にコミットしなければ行われず、変更無視はIStream、IStorageインターフェイスのRevertメソッドで行われる。
	SIMPLE           = STGM_SIMPLE,           /// CREATE | READWRITE | SHARE_EXCLUSIVE
	READ             = STGM_READ,             /// 読込み専用。
	WRITE            = STGM_WRITE,            /// 書き込み専用。
	READWRITE        = STGM_READWRITE,        /// READ | WRITE
	SHARE_DENY_NONE  = STGM_SHARE_DENY_NONE,  /// 読込み書き込み共、共有可能。
	SHARE_DENY_READ  = STGM_SHARE_DENY_READ,  /// READモードでの共有不可。
	SHARE_DENY_WRITE = STGM_SHARE_DENY_WRITE, /// WRITEモードでの共有不可。
	SHARE_EXCLUSIVE  = STGM_SHARE_EXCLUSIVE,  /// SHARE_DENY_READ | SHARE_DENY_WRITE
	PRIORITY         = STGM_PRIORITY,         /// ストレージを最も新しくコミットされたバージョンへの排他的アクセスで開く。$(DDOC_BLANKLINE)$(DDOC_BLANKLINE)したがって、他のユーザーはその間ストレージに対してコミットすることが出来ない。STGM_DIRECT or STGM_READを設定しておかなくてはならない。
	DELETEONRELEASE  = STGM_DELETEONRELEASE,  /// ルートストレージが破棄された時に自動的に破棄。
	CREATE           = STGM_CREATE,           /// 既存のストレージやストリームを破棄し、新しいものに置換える。$(DDOC_BLANKLINE)同名のストリームがある場合などに使用
	CONVERT          = STGM_CONVERT,          /// CONTENTSと命名されたストリームに既存のデータを保存し新しいオブジェクトを生成する。
	FAILIFTHERE      = STGM_FAILIFTHERE,      /// 同名のオブジェクトが存在した場合、オブジェクトの生成に失敗する。
	NOSCRATCH        = STGM_NOSCRATCH,        /// （Win95のみ）トランザクトモードにおいて、スクラッチファイルがコミット前に保存されるようになる。$(DDOC_BLANKLINE)元のファイルの不使用領域がスクラッチスペースとして使用される。
	NOSNAPSHOT       = STGM_NOSNAPSHOT,       /// このフラグは TRANSACTED フラグが指定されており、かつ SHARE_EXCLUSIVE も SHARE_DENY_WRITE も指定されずにストレージを開くときに使用できます。この場合、NOSNAPSHOT の指定によって、システムが提供するファイルのスナップショットコピー作成機能を抑制できます。 そのかわりに、ファイルへの変更はそのファイルの末尾に書き込まれます。 未使用の領域は、コミット操作によって整理されるまで、または、ファイルの書き込み利用者が一人になるまで再利用されません。スナップショットなしでファイルを開いた場合、NOSNAPSHOT を指定せずに他の場所でファイルを開くことはできなくなります。このフラグは、ルートストレージを開く時のみ使用できます。
}

/**
IPersistFile用interface。

IPersistFileを使用するComでオーバーライドさせると便利かも。
*/
interface IComPersistFile {
	/**
	Load。
	*/
	bool fileLoad(in Text FilePath, STGM Stgm);

	/**
	Save。

	Params:
		FilePath = フルパス指定のファイル名を表す文字列のアドレスを指定します。

		Remember = FilePathで指定したファイルをカレントファイルとして使用するかどうかを指定します。
		           trueを指定した場合は、FilePathがカレントファイルとなり、保存後にダーティーフラグ（更新されたかを示すフラグ）をクリアします。
		           falseを指定した場合は、カレントファイルは変化せず、ダーティーフラグはクリアされません。

	Returns:
		保存した出来たはtrue、失敗した場合はfalse。

	Note:
		オブジェクトが正常に保存された場合は 0x00000000 (S_OK) が返ります。
		オブジェクトが保存できなかった場合は 0x80004005 (E_FAIL) 返ります。
	*/
	bool fileSave(in Text FilePath, bool Remember);

	/***/
	bool isDirty();
}

