﻿/**
デイトタイムピッカー。

History:
	$(HIST_VER 1.032,
		$(HIST_MSG package名変更。)
	)
*/
module etc.negui.control.dtp.datetimepicker;

debug import std.stdio: wl = writefln;
debug(datetimepicker) void main() {}

import win32.windows;
import win32.commctrl;

import etc.negui.system.base;
import etc.negui.system.time;
public import etc.negui.negui;
public import etc.negui.control.control;

/***/
abstract class DateTimePicker: Control, ICommonControl {
	mixin MixInCommonControl;
	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_S 名前変更。)
		)
	*/
	static enum EVENT: MESSAGETYPE {
		DATETIMECHANGE = DTN_DATETIMECHANGE, ///
	}

	override this(ref NEGUIINFO NeGuiInfo) {
		NeGuiInfo.className = Text(DATETIMEPICK_CLASS);
		
		super(NeGuiInfo);
	}
	
	/// Bugs: エラー処理未実装
	DateTime value() {
		//SYSTEMTIME SystemTime=void;
		//send(DTM_GETSYSTEMTIME, NONE, cast(LPARAM)&SystemTime);
		SYSTEMDATETIME SystemDateTime=void;
		send(DTM_GETSYSTEMTIME, NONE, cast(LPARAM)SystemDateTime.ptr);
		auto date=new DateTime(DateTime.MODE.FLEXIBLE, SystemDateTime);
		return date;
	}
	/**
	*/
	void value(DateTime Value) {
		send(DTM_SETSYSTEMTIME, GDT_VALID, cast(LPARAM)Value.ptr);
	}
}

/***/
class DatePicker: DateTimePicker {
	///
	this(NeGui Owner, ITEM_ID Id) {
		NEGUIINFO NeGuiInfo;
		
		NeGuiInfo.owner     = Owner;
		NeGuiInfo.id        = Id;
		
		this(NeGuiInfo);
	}

	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_NEW)
		)
	*/
	override this(ref NEGUIINFO NeGuiInfo) {
		NeGuiInfo.style |= DTS_SHORTDATECENTURYFORMAT;
		
		super(NeGuiInfo);
	}
	///
	alias DateTimePicker.value value;
	/**
	*/
	override DateTime value() {
		auto Value=super.value();
		Value.mask = DateTime.MASK.DATE;
		return Value;
	}
}
/***/
class TimePicker: DateTimePicker {
	///
	this(NeGui Owner, ITEM_ID Id) {
		NEGUIINFO NeGuiInfo;
		
		NeGuiInfo.owner     = Owner;
		NeGuiInfo.id        = Id;
		
		//this(&NeGuiInfo);
		this(NeGuiInfo);
	}
	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_NEW)
		)
	*/
	override this(NEGUIINFO NeGuiInfo) {
		NeGuiInfo.style |= DTS_TIMEFORMAT;
		
		super(NeGuiInfo);
	}
	///
	alias DateTimePicker.value value;
	/**
	*/
	override DateTime value() {
		auto Value=super.value();
		Value.mask = DateTime.MASK.TIME;
		return Value;
	}
}

