﻿/**

History:
	$(HIST_VER 1.130,
		$(HIST_@ Advapi32のリンク。)
	)
*/
module etc.negui.environ.name;

debug import std.stdio: wl = writefln;
debug(name) void main() {}

import win32.winbase;

import etc.negui.system.base;
import etc.negui.environ.environ;

pragma(lib, "Advapi32.lib");

///
class NameException: EnvironException {
	mixin MixInNeGuiException;
}


private alias extern(Windows) BOOL function(LPWSTR, PDWORD) FuncType;
/**
History:
	$(HIST_VER 1.130,
		$(HIST_P tcharの対応。)
	)
	$(HIST_VER 1.100,
		$(HIST_S 戻り値をref。)
	)
*/
ref Text GetName(FuncType GetNameFunc, immutable size_t Length, lazy NameException ex) {
	DWORD len=Length;
	auto name=new tchar[len];
	
	if(!GetNameFunc(name.ptr, &len)) {
		throw ex;
	}

	return Text(name.ptr);
}

/**
ユーザー名取得。

* -------------------------------------------------------------------------------
* assert(UserName() == EnvToPlain(Text("%USERNAME%")));
* -------------------------------------------------------------------------------

Returns:
	取得したユーザー名。

Exception:
	取得失敗時にNameExceptionを投げる。
*/
ref Text UserName() {
	immutable UNLEN = 256;

	return GetName(
		cast(FuncType)&GetUserName,
		UNLEN,
		new NameException(Text("UserName:GetUserName"))
	);

}

/**
コンピューター名取得。

* -------------------------------------------------------------------------------
* assert(ComputerName() == EnvToPlain(Text("%USERDOMAIN%")));
* -------------------------------------------------------------------------------

Returns:
	取得したコンピューター名。

Exception:
	取得失敗時にNameExceptionを投げる。
*/
ref Text ComputerName() {
	immutable MAX_COMPUTERNAME_LENGTH = 256;
	
	return GetName(
		cast(FuncType)&GetComputerName,
		MAX_COMPUTERNAME_LENGTH,
		new NameException(Text("ComputerName:GetComputerName"))
	);
}
debug(name) unittest {
	wl("%s", ComputerName);
}

