﻿/**
環境変数。

History:
	$(HIST_VER 1.021,
		$(HIST_S module変更。)
	)
	$(HIST_VER 1.020,
		$(HIST_S package変更。。)
	)
*/
module etc.negui.environ.variable;

debug import std.stdio: wl = writefln;
debug(variable) void main() {}

import std.array;

import win32.windows;

import etc.negui.system.base;
import etc.negui.environ.environ;

///
class EnvVarException: EnvironException {
	mixin MixInNeGuiException;
}

/**
%**%の展開。

History:
	$(HIST_VER 1.130,
		$(HIST_@ tcharの対応。)
	)
*/
Text EnvToPlain(in Text EnvText)
in {
	assert(EnvText.length);
}
body {
	auto pEnvText=EnvText.ptr;
	DWORD Length=ExpandEnvironmentStrings(pEnvText, null, 0);

	auto text=new tchar[Length];
	ExpandEnvironmentStrings(pEnvText, text.ptr, Length);

	return Text(text[0..Length-1]);
}
/**
%**%の展開。

%が存在しない場合は引数をそのまま返す。

History:
	$(HIST_VER 1.130,
		$(HIST_CHG 名前, toPlain, ToPlain)
	)
*/
Text ToPlain(in Text t) {
	if(t.indexOf('%', Text.CASE_SENSITIVE.YES, Text.START.HEAD) == -1) {
		return cast(Text)t;
	}
	return EnvToPlain(t);
}
alias ToPlain toPlain;
debug(variable) {
	import win32.windows;
	import etc.negui.environ.name;
	unittest {
		Text t1="ComSpec";
		Text t2=t1;
		assert(ToPlain(t1) == t2);

		assert(EnvToPlain(Text(`%USERNAME%`)) == UserName);
	}
}

