﻿/**
ファイル検索。

Phobosはちっと使わない。
*/
module etc.negui.file.find;

debug import std.stdio: wl = writefln;

debug(find) void main() {}

import win32.windows;

import etc.negui.system.base;
import etc.negui.file.file;

/**
Note:
	名前が不思議だ。

History:
	$(HIST_VER 1.100,
		$(HIST_P タイムスタンプ追加とそれに伴い関連機能の変更。)
	)
	$(HIST_VER 1.081,
		$(HIST_S 色々変更。)
	)
	$(HIST_VER 1.00β13,
		$(HIST_S 隠蔽用ptrメソッド実装。)
		$(HIST_S 構造体変数を改名。)
	)
*/
struct FILEITEM {
	WIN32_FIND_DATA FindData;
	mixin(SMixInStructHiddenOriginal!(WIN32_FIND_DATA)(q{FindData}));

	/// ファイル属性。
	const FILE.ATTRIBUTE attributes() {
		return cast(FILE.ATTRIBUTE)FindData.dwFileAttributes;
	}

	/// 時間。てけとう。
	//alias FindData.ftCreationTime   createTime;
	const FILEDATETIME createFileDateTime() {
		return cast(FILEDATETIME)FindData.ftCreationTime;
	}
	
	/// ditto
	//alias FindData.ftLastAccessTime lastAccessTime;
	const FILEDATETIME accessFileDateTime() {
		return cast(FILEDATETIME)FindData.ftLastAccessTime;
	}

	/// ditto
	//alias FindData.ftLastWriteTime  lastWriteTime;
	const FILEDATETIME updateFileDateTime() {
		return cast(FILEDATETIME)FindData.ftLastWriteTime;
	}

	/**
	Note:
		fが不細工すぎる。
	*/
	const ref TIMESTAMP getTimeStamp() {
		auto TimeStamp=new TIMESTAMP;
		FILEDATETIME f;
		f=createFileDateTime;
		TimeStamp.create =new DateTime(DateTime.MODE.FLEXIBLE, f);
		f=accessFileDateTime;
		TimeStamp.access =new DateTime(DateTime.MODE.FLEXIBLE, f);
		f=updateFileDateTime;
		TimeStamp.update =new DateTime(DateTime.MODE.FLEXIBLE, f);
		return *TimeStamp;
	}

	/**
	History:
		$(HIST_VER 1.081,
			$(HIST_B サイズ求めれてなかった。)
		)
	*/
	const ulong size() {
		//return (FindData.nFileSizeHigh << DWORD.sizeof) + FindData.nFileSizeLow;
		if(FindData.nFileSizeHigh) {
			return cast(ulong)(FindData.nFileSizeHigh * DWORD.max)+1 + FindData.nFileSizeLow;
		} else {
			return FindData.nFileSizeLow;
		}
	}

	/// ファイル名。
	const Text name() {
		return Text(FindData.cFileName.ptr);
	}
	/// 8.3文字ファイル名。
	const Text shortName() {
		return Text(FindData.cAlternateFileName.ptr);
	}

	/**
	History:
		$(HIST_VER 1.00β14,
			$(HIST_S const属性追加。)
		)
	*/
	const bool isFolder() {
		return (FindData.dwFileAttributes & FILE.ATTRIBUTE.FOLDER) == FILE.ATTRIBUTE.FOLDER;
	}

	const bool isParentFolder() {
		return FindData.cFileName[0] == '.' && FindData.cFileName[1] == '\0';
	}
	const bool isBaseFolder() {
		return FindData.cFileName[0] == '.' && FindData.cFileName[1] == '.' && FindData.cFileName[2] == '\0';
	}
	/**
	History:
		$(HIST_VER 1.100,
			$(HIST_NEW)
		)
	*/
	const bool isFolderItems() {
		return !isParentFolder && !isBaseFolder;
	}

	/**
	History:
		$(HIST_VER 1.1000,
			$(HIST_S const追加。)
		)
	*/
	const ConsText toText() {
		Text Format = "[YYYY]/[MM]/[DD]  [hh]:[mm]";
		//auto Month  = Texts("01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12");
		Text Folder = isFolder ? "<DIR>": "     ";
		auto CreateTime=getTimeStamp.create;
		CreateTime.format = Format;//.text8;
		CreateTime.mask = DateTime.MASK.DATE | DateTime.MASK.HOUR | DateTime.MASK.MINUTE;
		return Text(
			`%s %s %8s %s`,
			CreateTime,
			Folder,
			size,
			name
		);
	}
	string toString() {
		return toText.toString;
	}
}

/**
ファイル検索。

History:
	$(HIST_VER 1.081,
		$(HIST_S 継承元変更。)
	)
	$(HIST_VER 1.00β14,
		$(HIST_S 使い道の無いであろうnewPatternメソッドを非推奨に。)
	)
*/
class Finder: HandleRaii {
	protected alias Handle hFind;
	mixin KillResource!("ファイル検索", hFind, FindClose, 0);
	mixin MixInHandleRaiiNotDuplicate;
	mixin MixInHandleRaiiNotDup;

	protected bool NextFind;

	/**
	History:
		$(HIST_VER 1.100,
			$(HIST_CHG 型, const wchar*, const Text)
		)
	*/
	protected const Text FilePattern;
	protected size_t Count;
	
	this(in Text FilePattern) {
		super(null, false);
		this.FilePattern = FilePattern;
	}

	/**
	History:
		$(HIST_VER 1.050,
			$(HIST_S deprecated修正。)
		)
	*/
	bool find(ref FILEITEM FileItem) {
		if(NextFind) {
			if(FindNextFile(hFind, FileItem.ptr)) {
				Count++;
				return true;
			} else {
				NextFind=false;
				return false;
			}
		} else {
			//auto FileFind=FindFirstFile(FilePattern, &FileItem.info);
			auto FileFind=FindFirstFile(FilePattern.ptr, FileItem.ptr);
			if(FileFind == INVALID_HANDLE_VALUE) {
				super.Suicide = false;
				return false;
			} else {
				super.Suicide = true;
				NextFind = true;
				hFind = FileFind;
				Count++;
				return true;
			}
		}
	}

	const size_t count() {
		return Count;
	}
}

/**
Finderの定型取得。

History:
	$(HIST_VER 1.090,
		$(HIST_CHG 名前, FINDER, FIND)
	)
	$(HIST_VER 1.081,
		$(HIST_NEW)
	)
*/
static struct FIND {
	static:

	/**
	History:
		$(HIST_VER 1.090,
			$(HIST_NEW)
		)
	*/
	FILEITEM[] find(in Text Pattern, FILE.ATTRIBUTE Attribute, size_t InitialValue=BUFFER.INITIAL, size_t Increment=BUFFER.INCREMENT) {
		scope finder=new Finder(Pattern);
		auto FileItems=new FILEITEM[InitialValue];
		FILEITEM FileItem;
		size_t i=0;
		
		while(finder.find(FileItem)) {
			if(Attribute == FILE.ATTRIBUTE.NONE || (FileItem.attributes & Attribute) == Attribute) {
				FileItems.autoIncrement(i, Increment);
				FileItems[i++] = FileItem;
			}
		}
		return FileItems[0 .. i];
	}

	
	/**
	指定フォルダ、指定パターンからファイル検索。
	
	History:
		$(HIST_VER 1.090,
			$(HIST_S 属性も考慮。)
		)
	*/
	FILEITEM[] list(in Text FolderPath, in Text Pattern, FILE.ATTRIBUTE Attribute, size_t InitialValue=BUFFER.INITIAL, size_t Increment=BUFFER.INCREMENT) {
		return find(PATH.join(FolderPath, Pattern), Attribute, InitialValue, Increment);
	}
	/**
	*/
	FILEITEM[] items(in Text FolderPath, size_t InitialValue=BUFFER.INITIAL, size_t Increment=BUFFER.INCREMENT) {
		return list(FolderPath, Text('*'), FILE.ATTRIBUTE.NONE, InitialValue, Increment);
	}
	/**
	*/
	FILEITEM[] files(in Text FolderPath, size_t InitialValue=BUFFER.INITIAL, size_t Increment=BUFFER.INCREMENT) {
		auto List=list(FolderPath, Text('*'), FILE.ATTRIBUTE.NONE, InitialValue, Increment);
		auto Result=new FILEITEM[List.length];
		size_t i;
		foreach(Value; List) {
			if(!Value.isFolder) {
				Result[i++] = Value;
			}
		}
		return Result[0 .. i];
	}
	/**
	*/
	FILEITEM[] folders(in Text FolderPath, size_t InitialValue=BUFFER.INITIAL, size_t Increment=BUFFER.INCREMENT) {
		return list(FolderPath, Text('*'), FILE.ATTRIBUTE.FOLDER, InitialValue, Increment);
	}
	
	debug(find) unittest {
		auto list=FIND.items(Text(`C:\`));
		foreach(file; list) {
			wl("%s", file);
		}
		wl("---------");
		list=FIND.files(Text(`C:\`));
		foreach(file; list) {
			wl("%s", file);
		}
		wl("---------");
		list=FIND.folders(Text(`C:\`));
		foreach(file; list) {
			wl("%s", file);
		}
	}
}

