﻿/**
デュアル。
*/
module etc.negui.layout.panel.dual;

debug import std.stdio: wl = writefln;
debug(dual) void main() {}

import std.math;
import std.exception;

import win32.windows;

import etc.negui.system.base;
import etc.negui.negui;
public import etc.negui.layout.layout;
public import etc.negui.layout.panel.panel;


/**
二画面型パネル。

領域を二分割。

Bugs:
	縦方向未チェック。

History:
	$(HIST_VER 1.062,
		$(HIST_P やっぱり中央線を変数からメソッドに。)
	)
	$(HIST_VER 1.050,
		$(HIST_P 中央線をメソッドから変数に。)
	)

*/
class Dual: Panel, IDirection {
	invariant() {
		assert(Contents.length == 2);
	}
	mixin TDirection;
	
	///
	SIZEINFO sizeInfo;
	
	///
	this(DIRECTION Direction) {
		this.Direction = Direction;
		Contents.length = 2;
	}
	
	///
	protected int CenterSize;
	mixin(SMixInStructGetSet!(int)("centerSize", q{CenterSize}));
	/**
	History:
		$(HIST_VER 1.030,
			$(HIST_S final switchの導入。)
			$(HIST_P 内部処理一部変更。)
		)
	*/
	override void onSize(ref const(RECT) TotalSize) {
		if(!Contents.length) {
			return;
		}
		
		SIZEINFO[2] SizeInfos;
		SizeInfos[0] = sizeInfo;
		SizeInfos[1].absolute = -1;
		
		int IncrementElementSize=0;

		foreach(i, Content; Contents) {
			auto InPaddingSize=GetInPaddingSize(TotalSize);
			
			bool LoopLast() {
				return i == Contents.lastIndex;
			}
			
			auto ContentSize=GetContentSize(InPaddingSize);
			
			final switch(Direction) {
				case DIRECTION.HORIZON:
					if(LoopLast()) {
						InPaddingSize.left += CenterSize - CenterSize/2;
					} else {
						InPaddingSize.right += CenterSize/2;
					}
					break;
				case DIRECTION.VERTICAL:
					if(LoopLast()) {
						InPaddingSize.top += CenterSize - CenterSize/2;
					} else {
						InPaddingSize.bottom += CenterSize/2;
					}
					break;
			}
			
			
			immutable ElementSize = GetElemntSize(Direction, SizeInfos[i], InPaddingSize);
			
			
			final switch(Direction) {
				case DIRECTION.HORIZON:
					ContentSize.left  = InPaddingSize.left + padding.left * (i + 1) + padding.right * i + IncrementElementSize;
					ContentSize.right = ContentSize.left + ElementSize;
				
					if(LoopLast()) {
						ContentSize.right = InPaddingSize.right  - padding.right;
					}
					break;
				
				case DIRECTION.VERTICAL:
					ContentSize.top    = InPaddingSize.top + padding.top * (i + 1) + padding.bottom * i + IncrementElementSize;
					ContentSize.bottom = ContentSize.top + ElementSize;
				
					if(LoopLast()) {
						ContentSize.bottom = InPaddingSize.bottom  - padding.bottom;
					}
					break;
			}
			IncrementElementSize += ElementSize;
			
			Content.onSize(ContentSize);
		}
	}
}

