﻿/**
タスクトレイ関連。

packageどこにしたらいいのか。

Bugs:
	古い。
*/
module etc.negui.tasktray;

debug import std.stdio: wl = writefln;

debug(tasktray) void main() {}

import std.exception;

import win32.windows;

import etc.negui.system.base;
//import nemuxi.base;
import etc.negui.draw.icon;
import etc.negui.negui;
import etc.negui.window.newindow;
//import etc.negui.system.raii;

///
class TaskTrayException: NeGuiException {
	mixin MixInNeGuiException;
}



///
typedef int TASK_ID;


/**
タスクトレイ用の人。

History:
	$(HIST_VER 1.032,
		$(HIST_S memberpropertyの適用。)
	)
*/
struct TASKTRAY {
	NOTIFYICONDATA NotifyIcon;
	mixin(SMixInStructHiddenOriginal!(NOTIFYICONDATA)(`NotifyIcon`));

	///
	class TaskTrayTextLengthException: TaskTrayException {
		mixin MixInNeGuiException;
	}

	void initialize() {
		NotifyIcon.cbSize = NotifyIcon.sizeof;
	}
	deprecated alias initialize sizeInit;

	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_S 属性変更。)
		)
	*/
	const NeWindow window() {
		return NotifyIcon.hWnd
			? cast(NeWindow)NeGui.getGuiObject(NotifyIcon.hWnd)
			: null
		;
	}
	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_S 引数属性変更。)
		)
	*/
	void window(in NeWindow window) {
		NotifyIcon.hWnd = window();
	}
	
	mixin(SMixInStructGetSet!(DWORD)("id", q{NotifyIcon.uID}));

	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_S 名前変更。)
		)
	*/
	static enum FLAG {
		MESSAGE = NIF_MESSAGE, /// uCallbackMessage
		ICON    = NIF_ICON, /// hIcon
		TIP     = NIF_TIP, /// szTip
		STATE   = NIF_STATE, /// Version 5.0 以降： dwState, dwStateMask
		INFO    = NIF_INFO, /// Version 5.0 以降： szInfo, uTimeout, szInfoTitle, dwInfoFlags
		GUID    = NIF_GUID, ///Version 6.0 以降： 予約されています。
	}
	mixin(SMixInStructGetSet!(FLAG)("flags", q{NotifyIcon.uFlags}));

	mixin(SMixInStructGetSet!(DWORD)("message", q{NotifyIcon.uCallbackMessage}));

	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_S 属性変更。)
		)
	*/
	const Icon icon() {
		return NotifyIcon.hIcon
			? new Icon(NotifyIcon.hIcon, false)
			: null
		;
	}
	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_S 引数属性変更。)
		)
	*/
	void icon(in Icon icon) {
		NotifyIcon.hIcon = icon();
	}

	static invariant auto TEXT_MAX = 128;
	Text tips()
	out(r) {
		assert(r.length < TEXT_MAX);
	}
	body {
		Text text=NotifyIcon.szTip.ptr;
		return text;
	}
	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_P 例外出力内容変更。)
			$(HIST_S 引数属性変更。)
		)
	*/
	void tips(in Text text) {
		if(text.length >= TEXT_MAX) {
			throw new TaskTrayTextLengthException(Text("tool tip length over[%s]", text));
		}
		//NotifyIcon.szTip = text.text;
		lstrcpy(NotifyIcon.szTip.ptr, text.ptr);
	}

	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_S 名前変更。)
		)
	*/
	static enum STATE {
		NONE       = 0,
		HIDDEN     = NIS_HIDDEN, /// アイコンは非表示です。
		SHAREDICON = NIS_SHAREDICON, /// アイコンは共有されます。
	}
	deprecated alias STATE NIS;
	mixin(SMixInStructGetSet!(STATE)("state", q{NotifyIcon.dwState}));
	mixin(SMixInStructGetSet!(STATE)("stateMask", q{NotifyIcon.dwStateMask}));

	static invariant auto INFO_MAX = 255;
	Text infoTips()
	out(r) {
		assert(r.length < INFO_MAX);
	}
	body {
		Text text=NotifyIcon.szInfo.ptr;
		return text;
	}
	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_P 例外出力内容変更。)
			$(HIST_S 引数属性変更。)
		)
	*/
	void infoTips(in Text text) {
		if(text.length >= INFO_MAX) {
			throw new TaskTrayTextLengthException(Text("info tip length over[%s]", text));
		}
		//NotifyIcon.szTip = text.text;
		lstrcpy(NotifyIcon.szInfo.ptr, text.ptr);
	}

	mixin(SMixInStructGetSet!(UINT)("timeOut", q{NotifyIcon.uTimeout}));
	
	static enum VER {
		WIN95 = 0,
		WIN2K = NOTIFYICON_VERSION
	}
	mixin(SMixInStructGetSet!(VER)("ver", q{NotifyIcon.uVersion}));

	static invariant auto TITLE_MAX = 64;
	Text infoTitle()
	out(r) {
		assert(r.length < TITLE_MAX);
	}
	body {
		Text text=NotifyIcon.szInfoTitle.ptr;
		return text;
	}
	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_P 例外出力内容変更。)
			$(HIST_S 引数属性変更。)
		)
	*/
	void infoTitle(in Text text) {
		if(text.length >= TITLE_MAX) {
			throw new TaskTrayTextLengthException(Text("info title length over[%s]", text));
		}
		lstrcpy(NotifyIcon.szInfoTitle.ptr, text.ptr);
	}
	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_S 名前変更。)
		)
	*/
	static enum INFORMATION {
		NONE      = NIIF_NONE,      /// アイコンなし
		INFO      = NIIF_INFO,      /// 「情報」アイコン
		WARNING   = NIIF_WARNING,   /// 「警告」アイコン
		ERROR     = NIIF_ERROR,     /// 「エラー」アイコン
		ICON_MASK = NIIF_ICON_MASK, /// Version 6.0 以降： 予約されています。
		NOSOUND   = NIIF_NOSOUND,   /// Version 6.0 以降： 関連サウンドを鳴らさないようにします。バルーンツールチップにのみ適用されます。
	}
	deprecated alias INFORMATION NIIF;
	mixin(SMixInStructGetSet!(INFORMATION)("infoFlag", q{NotifyIcon.dwInfoFlags}));
}

private enum {
	NIN_BALLOONSHOW      = 0x402, /// バルーンが表示されたとき
	NIN_BALLOONHIDE      = 0x403, /// バルーンが消えたとき（アイコンが消えたときなど）
	NIN_BALLOONTIMEOUT   = 0x404, /// タイムアウトによりバルーンが消えたとき
	NIN_BALLOONUSERCLICK = 0x405, /// ユーザーのマウスクリックによってバルーンが消えたとき
}

/**
タスクトレイ。

$(DELETE
	これなんで抽象クラスなんだろ。
	もう忘れたなぁ。
)

History:
	$(HIST_VER 1.100,
		$(HIST_S 抽象クラスじゃなくした。だけ。)
	)
*/
class TaskTray: Raii {
	/**
	Note:
		MOUSEMOVE-MBUTTONDBLCLKは無くてもいいかも。
	
	History:
		$(HIST_VER 1.032,
			$(HIST_NEW)
		)
	*/
	enum EVENT: MESSAGETYPE {
		MOUSEMOVE     = win32.winuser.WM_MOUSEMOVE,     /// 
		LBUTTONDOWN   = win32.winuser.WM_LBUTTONDOWN,   /// 
		LBUTTONUP     = win32.winuser.WM_LBUTTONUP,     /// 
		LBUTTONDBLCLK = win32.winuser.WM_LBUTTONDBLCLK, /// 
		RBUTTONDOWN   = win32.winuser.WM_RBUTTONDOWN,   /// 
		RBUTTONUP     = win32.winuser.WM_RBUTTONUP,     /// 
		RBUTTONDBLCLK = win32.winuser.WM_RBUTTONDBLCLK, /// 
		MBUTTONDOWN   = win32.winuser.WM_MBUTTONDOWN,   /// 
		MBUTTONUP     = win32.winuser.WM_MBUTTONUP,     /// 
		MBUTTONDBLCLK = win32.winuser.WM_MBUTTONDBLCLK, /// 

		BALLOONSHOW      = NIN_BALLOONSHOW,      /// バルーンが表示されたとき
		BALLOONHIDE      = NIN_BALLOONHIDE,      /// バルーンが消えたとき（アイコンが消えたときなど）
		BALLOONTIMEOUT   = NIN_BALLOONTIMEOUT,   /// タイムアウトによりバルーンが消えたとき
		BALLOONUSERCLICK = NIN_BALLOONUSERCLICK, /// ユーザーのマウスクリックによってバルーンが消えたとき
	}
	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_S 属性変更。)
		)
	*/
	static immutable UINT WM_TASKBAR_CREATED;
	//alias WM_TASKBAR_CREATED WM_TASKBAR_CREATED;
	//deprecated alias WM_TASKBAR_CREATED TaskBar;
	/**
	History:
		$(HIST_VER 1.050,
			$(HIST_S deprecated修正。)
		)
	*/
	static this() {
		WM_TASKBAR_CREATED = RegisterWindowMessage(Text("TaskbarCreated").ptr);
		auto Code=ERR.code;
		///
		class TaskTrayTaskbarCreatedException: TaskTrayException {
			mixin MixInNeGuiException;
		}
		enforce(WM_TASKBAR_CREATED, new TaskTrayTaskbarCreatedException(ERR.toText(Code)));
	}
	/**
	History:
		$(HIST_VER 1.050,
			$(HIST_S 名前変更。)
		)
	*/
	private static enum MESSAGE: UINT {
		ADD    = NIM_ADD, /// ステータスエリアにアイコンを追加します。
		MODIFY = NIM_MODIFY, /// アイコンを変更します。
		DELETE = NIM_DELETE, /// アイコンを削除します。
		SETFOCUS = NIM_SETFOCUS, /// Version 5.00 以降： タスクバー通知エリアにフォーカスを返します。タスクバーアイコンは、ユーザーインターフェース操作が完了したときにこのメッセージを送るべきです。例えば、タスクバーアイコンにショートカットメニューを表示して、ユーザーが ESC キーを押してキャンセルしたときに、このメッセージを送信してフォーカスをタスクバー通知エリアに返すべきです。
		SETRVERSION = NIM_SETVERSION, /// Version 5.00 以降： pnid パラメータで指定される NOTIFYICONDATA 構造体の uVersion メンバで指定されるバージョンに従って振舞うようにタスクバーに指定します。このメンバのデフォルト値は 0 であり、原型の Windows 95 の通知アイコンにおける振舞いになります。
	}
	deprecated alias MESSAGE NIM;
	
	this(bool Suicide=false) {
		super(Suicide);
	}

	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_NEW)
		)
	*/
	private bool Notify(MESSAGE Message, const ref TASKTRAY Tray) {
		return cast(bool)Shell_NotifyIcon(Message, Tray.ptr);
	}

	/**
	History:
		$(HIST_VER 1.120,
			$(HIST_B 自信ないけどタイムアウトとそれ以外の失敗が逆だった？)
		)
		$(HIST_VER 1.050,
			$(HIST_S deprecated修正。)
		)
		$(HIST_VER 1.032,
			$(HIST_NEW)
		)
	*/
	final bool addTray(const ref TASKTRAY Tray, bool WaitFlag=false, uint WaitTime=500, size_t LoopCount=5)
	in {
		if(WaitFlag) {
			assert(WaitTime);
			assert(LoopCount);
		}
	}
	body {
		if(!WaitFlag) {
			return Notify(MESSAGE.ADD, Tray);
		} else {
			size_t i=0;
			try {
				do {
					ERR.initialize;
					if(Notify(MESSAGE.ADD, Tray)) {
						return true;
					} else if(ERR.code != ERROR_TIMEOUT) {
						throw new TaskTrayException(ERR.toText);
					} else if(this.modifyTray(Tray)) {
						return true;
					} else {
						Sleep(WaitTime);
					}
				} while(LoopCount > i++)

				///
				class TaskTrayTimeOutException: TaskTrayException {
					mixin MixInNeGuiException;
				}
				throw new TaskTrayTimeOutException(ERR.toText);
				
			} catch(TaskTrayException e) {
				///
				class TaskTrayAddFailureException: TaskTrayException {
					mixin MixInNeGuiException;
				}
				throw new TaskTrayAddFailureException(Text("failure."), e);
			}
		}
	}
	
	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_NEW)
		)
	*/
	final bool modifyTray(const ref TASKTRAY Tray) {
		return Notify(MESSAGE.MODIFY, Tray);
	}
	
	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_NEW)
		)
	*/
	final bool deleteTray(const ref TASKTRAY Tray) {
		return Notify(MESSAGE.DELETE, Tray);
	}

	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_NEW)
		)
	*/
	final bool focusTray(const ref TASKTRAY Tray) {
		return Notify(MESSAGE.SETFOCUS, Tray);
	}

	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_NEW)
		)
	*/
	final bool versionTray(const ref TASKTRAY Tray) {
		return Notify(MESSAGE.SETRVERSION, Tray);
	}
}



